#################################################################################
# Created       : Martin Foster
# Modified      : 05-May-2003
#################################################################################
#
# Template - Module part of Ethereal Realms, designed to standardize display
# Copyright (C) 2000-2004  Martin Foster
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# Author of this script can be contacted at the following:
#       E-Mail  : martin@ethereal-realms.org
#       Address : 29-26503 TWP RD 511
#                 Spruce Grove, Alberta
#                 T7Y 1G4
#
#################################################################################

package eRealms::Template;					# Package name

#################################################################################
# Sub-Routines
#################################################################################

#####################
# Constructor
#
# Allows to class to be exported and thus spawn objects as a result

sub new
{
        my $class = shift;                                      # Self reference
        my $dbm   = shift;                                      # CGI handle

        my $self = {DBM => $dbm};
        bless $self, $class;                                    # Bless $self into designated class
        return $self;
}



#####################
# Display
#
# Really just a wrapper for the process of doing replacements and
# sending off a finished product back to the calling script.

sub Process
{
	#####################
	# Data members
	my $self     = shift;					# Reference to self
	my $choice   = shift;					# Choice of the matter
	my $field    = shift;					# Field name

	my $dbm      = $self->{'DBM'};				# Pull DBM values
	my $template = $dbm->{$field};				# Template to modify

	my $search;						# Search attribute
	my $value;						# Replacement value

	#####################
	# Program area

	# Loop through every second parameter
	while ($search = shift)
	{
		# Pull value
		$value = shift;

		# Replace
		$template =~ s/$search/$value/gs;
	}

	# Return results
	if ($choice < 2)
	{ print $template; }

	else
	{ return $template; }
}

# Main classes
# Alias for display
sub Show
{ Process(shift, 1, @_); }

# Alias for return
sub Pass
{ Process(shift, 2, @_);}


# Quick clases
# Show
sub ShowMain
{ Process(shift, 1, 'TmplMain', 'MTITLE', @_); }

sub ShowTitle
{ Process(shift, 1, 'TmplTitle', 'MTITLE', @_); }

sub ShowSub
{ Process(shift, 1, 'TmplSub', 'MTITLE', @_); }

# Pass
sub PassMain
{ Process(shift, 2, 'TmplMain', 'MTITLE', @_); }

sub PassTitle
{ Process(shift, 2, 'TmplTitle', 'MTITLE', @_); }

sub PassSub
{ Process(shift, 2, 'TmplSub', 'MTITLE', @_); }

1;								# Return True
